# auto generated by update_py.py
from datetime import datetime
import sys
import os

def nano_to_str(nano, fmt='%Y%m%d-%H:%M:%S'):
    ts = nano / 1e9
    return datetime.utcfromtimestamp(ts).strftime(fmt)

def bytify(ss):
    if sys.version_info < (3, 0):
        data = bytes(ss)
    else:
        data = bytes(ss, 'utf8')
    return data

def get_windows_first_disk():
    for i in range(65, 91):
        vol = chr(i) + ":"
        if os.path.isdir(vol):
            return vol

    raise EnvironmentError("could not get the right disk")

def get_linker_base_path():
    # python2: linux2, python3: linux
    if sys.platform.startswith("linux"):
        dirs = "/shared/log"
    elif sys.platform == "darwin":
        dirs = "/tmp/linker/log"
    elif sys.platform == "win32":
        dirs = os.path.join(get_windows_first_disk() + "/tmp/linker/log")
    else:
        raise TypeError('your {} system is not supported'.format(sys.platform))

    if not os.path.exists(dirs):
        os.makedirs(dirs)
    return dirs
